QGIS Application - Bug report #17254
Wrong output CRS when input layer uses generated CRS
2017-10-06 07:09 PM - Anita Graser

Status: Closed

Priority: Normal

Assignee: Victor Olaya

Category: Processing/Core

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed/implemented
Crashes QGIS or corrupls data: Copied to github as #: 25152
Description

Tested with qgis:fixeddistancebuffer, native:dissolve, and native:buffer using OSGeo4W 2.99

If the input layer uses a generated / custom CRS, the output layer is loaded in a wrong CRS. In my case, the layers were wrongly assigned
WGS84. Note that, in settings, I've configured that QGIS should "prompt for CRS" if a layer without CRS info is loaded.

Associated revisions

Revision 8cb48938 - 2017-12-18 12:27 AM - Nyall Dawson

Fix creation of QgsCoordinateReferenceSystem from "user:xxxx" strings

Fixes #17254

History

#1 - 2017-12-16 08:42 PM - Steven Mizuno

| was making a run at this problem to better understand QGIS and found that trying to create a scratch (memory) vector layer with a user CRS would get a
CRS selection dialog, even though the CRS field was filled, where a standard EPSG.... did not.

Using Python console | tried this, which works (no CRS selection dialog):
v=QgsVectorLayer("Polygon?crs=epsg:4326", "Layer Name", "memory")
and:

v1=QgsVectorLayer("Polygon?crs=user:100028", "Layer Name", "memory")
which pops the CRS selection dialog; choosing USER:100028 works. | thought that the selection dialog shouldn't have been invoked.

So it seems that the USER:... CRS is NOT being interpreted properly -- where, I'm not sure yet, as | was calling QgsVectorLayer directly.

| had noticed before (another issue) that QgsCoordinateReferenceSystem::createFromString() expects 'INTERNAL' for any srsid incl. the notion of
'USER!, else 'EPSG!' or 'POSTGIS' or 'PROJ4' or 'WKT'.

It seemed to me that this function could be amended to include 'USER' and would handle the value same as for INTERNAL.

YES! -- added '|user' to the regex string -- this works -- is there any side effect?

Have tried Processing:Buffer with this fix, with data in USER:100028 and now creates the memory layer correctly.
Alternative is to detect and replace 'USER' with 'INTERNAL' everywhere createFromString is called in a layer provider or any other use of USER CRSes.
QgsCoordinateReferenceSystem::createFromOgcWmsCrs() does deal with 'USER', but has still other notions, like: 'custom’, and 'qgis' -- this is confusing.

Note that in the original problem described the layer data actually is in the expected CRS; it is just that the layer was assigned the wrong CRS when
loaded.
#2 - 2017-12-18 06:36 AM - Nyall Dawson
- % Done changed from 0 to 100
- Status changed from Open to Closed

Applied in changeset commit:qgis|8cb4893817e4efe8752c4b14c3c69da9f701a417.

#3 - 2018-02-22 11:50 AM - Giovanni Manghi
- Resolution set to fixed/implemented
